import { Binary, Getter } from '../utils';
export declare namespace Hierarchy {
    type Node = {
        pointCount: number;
        pointDataOffset: number;
        pointDataLength: number;
    };
    namespace Node {
        type Map = Record<string, Node | undefined>;
    }
    type Page = {
        pageOffset: number;
        pageLength: number;
    };
    namespace Page {
        type Map = Record<string, Page | undefined>;
    }
    type Subtree = {
        nodes: Node.Map;
        pages: Page.Map;
    };
}
export declare const Hierarchy: {
    parse: typeof parse;
    load: typeof load;
};
declare function parse(buffer: Binary): Hierarchy.Subtree;
declare function load(filename: string | Getter, page: Hierarchy.Page): Promise<Hierarchy.Subtree>;
export {};
//# sourceMappingURL=hierarchy.d.ts.map