import { Binary, Dimension } from '../utils';
export declare namespace ExtraBytes {
    type Options = {
        hasNodata: boolean;
        hasMin: boolean;
        hasMax: boolean;
        hasScale: boolean;
        hasOffset: boolean;
    };
}
export type ExtraBytes = {
    name: string;
    description: string;
    type?: Dimension.Type;
    length: number;
    nodata?: number;
    min?: number;
    max?: number;
    scale?: number;
    offset?: number;
};
export declare const ExtraBytes: {
    getDimension: typeof getDimension;
    parse: typeof parse;
    parseOne: typeof parseOne;
};
declare function getDimension({ type, length: size, }: ExtraBytes): Dimension | undefined;
declare function parse(buffer: Binary): ExtraBytes[];
declare function parseOne(buffer: Binary): ExtraBytes;
export {};
//# sourceMappingURL=extra-bytes.d.ts.map