import { Point } from './point';
import { Key } from './key';
import { Step } from './step';
export type Bounds = [...Point, ...Point];
export declare const Bounds: {
    min: typeof min;
    max: typeof max;
    mid: typeof mid;
    width: typeof width;
    depth: typeof depth;
    height: typeof height;
    cube: typeof cube;
    step: typeof step;
    stepTo: typeof stepTo;
    intersection: typeof intersection;
};
declare function min(b: Bounds): Point;
declare function max(b: Bounds): Point;
declare function mid([minx, miny, minz, maxx, maxy, maxz]: Bounds): Point;
declare function width(bounds: Bounds): number;
declare function depth(bounds: Bounds): number;
declare function height(bounds: Bounds): number;
declare function cube(bounds: Bounds): Bounds;
declare function step(bounds: Bounds, [a, b, c]: Step): Bounds;
declare function stepTo(bounds: Bounds, [d, x, y, z]: Key): [number, number, number, number, number, number];
declare function intersection(a: Bounds, b: Bounds): Bounds;
export {};
//# sourceMappingURL=bounds.d.ts.map